package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.EmpresaEmailFlexBusDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaEmailFlexBus;
import com.rjconsultores.ventaboletos.service.EmpresaEmailFlexBusService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("empresaEmailFlexBUsService")
public class EmpresaEmailFlexBusServiceImpl implements EmpresaEmailFlexBusService {

	@Autowired
	private EmpresaEmailFlexBusDAO empresaEmailDAO;

	@Override
	public List<EmpresaEmailFlexBus> obtenerTodos() {
		return empresaEmailDAO.obtenerTodos();
	}

	@Override
	public EmpresaEmailFlexBus obtenerID(Integer id) {
		return empresaEmailDAO.obtenerID(id);
	}

	@Override
	@Transactional
	public EmpresaEmailFlexBus suscribir(EmpresaEmailFlexBus entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return empresaEmailDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public EmpresaEmailFlexBus actualizacion(EmpresaEmailFlexBus entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return empresaEmailDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(EmpresaEmailFlexBus entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		empresaEmailDAO.actualizacion(entidad);

	}

	@Override
	public EmpresaEmailFlexBus buscarPorEmpresa(Empresa empresa) {
		return empresaEmailDAO.buscarPorEmpresa(empresa);
	}

}
